﻿assert( RogueTimerFu, "RogueTimerFu not found!")
local BS = AceLibrary("Babble-Spell-2.2")
local L = AceLibrary("AceLocale-2.2"):new("RogueTimerFu")
local parser = ParserLib:GetInstance("1.1")

RogueTimerFu_Rules = RogueTimerFu:NewModule("RogueTimerFu_Rules")
RogueTimerFu_Rules.Rules = {}
RogueTimerFu_Rules.defaults = {}
RogueTimerFu_Rules.timers = {}
RogueTimerFu_Rules.Menu = {}

function RogueTimerFu_Rules:OnInitialize()
self.settings = RogueTimerFu:AcquireDBNamespace("BuffTimer")
for _, v in pairs(self.timers) do
		v(self)
end
RogueTimerFu:RegisterDefaults("BuffTimer", "profile", RogueTimerFu_Rules.defaults)
for k in pairs(self.Menu) do
RogueTimerFu.Menu.args[L[k]] = {
	type = "group",
	order = 4,
	name = L[k],
	desc = L["Which Buffs to show."],
	args = {}
}
for v in pairs(self.Menu[k]) do
local name = RogueTimerFu_Rules:ReverseTranslation(v)
	RogueTimerFu.Menu.args[L[k]].args[name] = {
		order = 3,
		type = 'toggle',
		name = name,
	    desc = L["Enable/Dissable the timer"],
	    get = function()
	        return self.settings.profile[v]
	    end,
	    set = function()
			self.settings.profile[v] = not self.settings.profile[v]
		end,
		map = { [false] = "Disabled", [true] = "Enabled" }
}
end
end
RogueTimerFu_Rules.Menu = nil
end

function RogueTimerFu_Rules:OnEnable()
self:RegisterEvent("UNIT_SPELLCAST_SENT", "spell")
self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED", "spellSent")
parser:RegisterEvent("RogueTimerFu_Rules", "CHAT_MSG_SPELL_AURA_GONE_SELF", RogueTimerFu_Rules.parser)
parser:RegisterEvent("RogueTimerFu_Stun", "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE", RogueTimerFu_Rules.parser)
parser:RegisterEvent("RogueTimerFu_Stun", "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE", RogueTimerFu_Rules.parser)
parser:RegisterEvent("RogueTimerFu_Stun", "CHAT_MSG_SPELL_SELF_DAMAGE", RogueTimerFu_Rules.parser)
parser:RegisterEvent("RogueTimerFu_Stun", "CHAT_MSG_SPELL_AURA_GONE_OTHER", RogueTimerFu_Rules.parser)
parser:RegisterEvent("RogueTimerFu_Stun", "CHAT_MSG_SPELL_BREAK_AURA", RogueTimerFu_Rules.parser)
end

function RogueTimerFu_Rules:AddRule(group, name, table)
if not table.d then table.d = {} end
if not RogueTimerFu_Rules.Menu[group] then RogueTimerFu_Rules.Menu[group] = {} end
RogueTimerFu_Rules.Menu[group][name] = table
RogueTimerFu_Rules.Rules[name] = table
self.defaults[name] = true
end

function RogueTimerFu_Rules:OnDisable()
parser:UnregisterAllEvents("RogueTimerFu_Rules")
end

--Parsing
function RogueTimerFu_Rules:spell()
	self.Combo = GetComboPoints()
	self.Rank = arg3
	self.Skill = arg2
	--self.Target = arg4
	--self.Player = UnitIsPlayer("target")
end

function RogueTimerFu_Rules:spellSent()
if BS:HasReverseTranslation(arg2) then
if self.settings.profile[RogueTimerFu_Rules:ReverseTranslation(arg2)] and 
arg2 ~= BS["Stealth"] and self.Rules[RogueTimerFu_Rules:ReverseTranslation(arg2)].event then
	RogueTimerFu_Rules:Bars(arg2, self.Combo)
end
end
end

function RogueTimerFu_Rules:parser(info)
local self = RogueTimerFu_Rules
if info.type == "debuff" or info.type == "cast" then
	if info.skill == self.Skill then
		if self.settings.profile[RogueTimerFu_Rules:ReverseTranslation(info.skill)] then
			RogueTimerFu_Rules:Bars(info.skill, self.Combo, self.Rank, self.Target)
		end
	end
elseif info.type == "fade" then
	if info.skill ~= BS["Stealth"] then
		RogueTimerFu_Bars:RogueTimerFu_StopBar(self, info.skill)
		if self.settings.profile["Diminishing returns"] and self.Rules[RogueTimerFu_Rules:ReverseTranslation(info.skill)] and self.Rules[RogueTimerFu_Rules:ReverseTranslation(info.skill)].dr then
		--	if self.Target == info.victim then
				if self.Rules[RogueTimerFu_Rules:ReverseTranslation(info.skill)].dr == 1 then
					RogueTimerFu_Rules:Bars("DR: CS", nil, nil, info.victim)
				elseif self.Rules[RogueTimerFu_Rules:ReverseTranslation(info.skill)].dr == 2 then--and self.Player then
					RogueTimerFu_Rules:Bars("DR: Incapitating", nil, nil, info.victim)
				elseif self.Rules[RogueTimerFu_Rules:ReverseTranslation(info.skill)].dr == 3 then
					RogueTimerFu_Rules:Bars("DR: KS", nil, nil, info.victim)
				end
		--	end
		end
	elseif info.skill == BS["Stealth"] and info.victim == ParserLib_SELF then
		if self.settings.profile["Master of Subtlety"] then
			RogueTimerFu_Rules:Bars("Master of Subtlety")
		end
	end
end
end

--Bars
function RogueTimerFu_Rules:Bars(move, combo, rank, target)
local B = self.Buffs
local Emove = RogueTimerFu_Rules:ReverseTranslation(move)
local path =  string.find(move, "DR") and BS:GetSpellIcon("Sap") or move == "Master of Subtlety" and BS:GetSpellIcon("Stealth") or BS:GetSpellIcon(Emove)
local time = string.find(move, "DR") and 15 or RogueTimerFu_Rules:GetDuration(RogueTimerFu_Rules.Rules[move].d, RogueTimerFu_Rules.Rules[move].time, combo, rank)
local move = RogueTimerFu_Rules:ReverseTranslation(move)
if time == 0 then return end
RogueTimerFu_Bars:RogueTimerFu_StartBar(RogueTimerFu_Rules, move, target, time, path)
end

function RogueTimerFu_Rules:GetDuration(record, duration, cp, rank)
	if record.cp then duration = duration + ((cp or GetComboPoints()) - 1) * record.cp end
	if record.rs then duration = duration + (RogueTimerFu_Rules:NumRank(rank)-1) * record.rs end
	if record.tn then
		local _,_,_,_, tr = GetTalentInfo(unpack(record.tn))
		if record.to == 1 and tr < 1 then return 0 end
		if tr > 0 and record.to ~= 1 then
			local gain = record.tt and record.tt[tr] or (record.tb + (tr-1) * (record.ts or record.tb))
			duration = duration + (record.tp and (duration/100) * gain or gain)
		end
	end
	if record.p and UnitIsPlayer("target") then duration = record.p end
	return duration
end 

function RogueTimerFu_Rules:ReverseTranslation(arg)
if BS:HasTranslation(arg) then
	return BS:GetReverseTranslation(arg)
elseif L:HasTranslation(arg) then
	return L:GetReverseTranslation(arg)
end
return nil
end

function RogueTimerFu_Rules:NumRank(rank)
local _, _, _, rank = string.find(rank, "(.+) (%d+)")
return rank
end 